Loading...
Searching...
No Matches
or/unmlq: Multiply by Q from LQ factorization
Dense LA » Orthogonal/unitary factorizations » LQ factorization

## Functions

magma_int_t | magma_cunmlq (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex *tau, magmaFloatComplex *C, magma_int_t ldc, magmaFloatComplex *work, magma_int_t lwork, magma_int_t *info)
| CUNMLQ overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_dormlq (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, double *A, magma_int_t lda, double *tau, double *C, magma_int_t ldc, double *work, magma_int_t lwork, magma_int_t *info)
| DORMLQ overwrites the general real M-by-N matrix C with.
magma_int_t | magma_sormlq (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, float *A, magma_int_t lda, float *tau, float *C, magma_int_t ldc, float *work, magma_int_t lwork, magma_int_t *info)
| SORMLQ overwrites the general real M-by-N matrix C with.
magma_int_t | magma_zunmlq (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex *tau, magmaDoubleComplex *C, magma_int_t ldc, magmaDoubleComplex *work, magma_int_t lwork, magma_int_t *info)
| ZUNMLQ overwrites the general complex M-by-N matrix C with.

## Detailed Description

## Function Documentation

## magma_cunmlq()

magma_int_t magma_cunmlq | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex * | C,
|  | magma_int_t | ldc,
|  | magmaFloatComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

CUNMLQ overwrites the general complex M-by-N matrix C with.

                             SIDE = MagmaLeft     SIDE = MagmaRight
    TRANS = MagmaNoTrans:    Q * C                C * Q
    TRANS = Magma_ConjTrans: Q**H * C             C * Q**H

where Q is a complexunitary matrix defined as the product of k elementary reflectors

      Q = H(k)**H . . . H(2)**H H(1)**H

as returned by CGELQF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in] | A | COMPLEX array, dimension (LDA,M) if SIDE = MagmaLeft, (LDA,N) if SIDE = MagmaRight. The i-th row must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by CGELQF in the first k rows of its array argument A. A is modified by the routine but restored on exit.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,K).
  [in] | tau | COMPLEX array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by CGELQF.
  [in,out] | C | COMPLEX array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) COMPLEX array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance if SIDE = MagmaLeft, LWORK >= N*NB; if SIDE = MagmaRight, LWORK >= M*NB, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dormlq()

magma_int_t magma_dormlq | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | double * | A,
|  | magma_int_t | lda,
|  | double * | tau,
|  | double * | C,
|  | magma_int_t | ldc,
|  | double * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

DORMLQ overwrites the general real M-by-N matrix C with.

                             SIDE = MagmaLeft     SIDE = MagmaRight
    TRANS = MagmaNoTrans:    Q * C                C * Q
    TRANS = MagmaTrans: Q**H * C             C * Q**H

where Q is a realorthogonal matrix defined as the product of k elementary reflectors

      Q = H(k)**H . . . H(2)**H H(1)**H

as returned by DGELQF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in] | A | DOUBLE PRECISION array, dimension (LDA,M) if SIDE = MagmaLeft, (LDA,N) if SIDE = MagmaRight. The i-th row must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by DGELQF in the first k rows of its array argument A. A is modified by the routine but restored on exit.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,K).
  [in] | tau | DOUBLE PRECISION array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by DGELQF.
  [in,out] | C | DOUBLE PRECISION array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) DOUBLE PRECISION array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance if SIDE = MagmaLeft, LWORK >= N*NB; if SIDE = MagmaRight, LWORK >= M*NB, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sormlq()

magma_int_t magma_sormlq | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | float * | A,
|  | magma_int_t | lda,
|  | float * | tau,
|  | float * | C,
|  | magma_int_t | ldc,
|  | float * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

SORMLQ overwrites the general real M-by-N matrix C with.

                             SIDE = MagmaLeft     SIDE = MagmaRight
    TRANS = MagmaNoTrans:    Q * C                C * Q
    TRANS = MagmaTrans: Q**H * C             C * Q**H

where Q is a realorthogonal matrix defined as the product of k elementary reflectors

      Q = H(k)**H . . . H(2)**H H(1)**H

as returned by SGELQF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in] | A | REAL array, dimension (LDA,M) if SIDE = MagmaLeft, (LDA,N) if SIDE = MagmaRight. The i-th row must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by SGELQF in the first k rows of its array argument A. A is modified by the routine but restored on exit.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,K).
  [in] | tau | REAL array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by SGELQF.
  [in,out] | C | REAL array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) REAL array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance if SIDE = MagmaLeft, LWORK >= N*NB; if SIDE = MagmaRight, LWORK >= M*NB, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zunmlq()

magma_int_t magma_zunmlq | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex * | C,
|  | magma_int_t | ldc,
|  | magmaDoubleComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

ZUNMLQ overwrites the general complex M-by-N matrix C with.

                             SIDE = MagmaLeft     SIDE = MagmaRight
    TRANS = MagmaNoTrans:    Q * C                C * Q
    TRANS = Magma_ConjTrans: Q**H * C             C * Q**H

where Q is a complexunitary matrix defined as the product of k elementary reflectors

      Q = H(k)**H . . . H(2)**H H(1)**H

as returned by ZGELQF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in] | A | COMPLEX_16 array, dimension (LDA,M) if SIDE = MagmaLeft, (LDA,N) if SIDE = MagmaRight. The i-th row must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by ZGELQF in the first k rows of its array argument A. A is modified by the routine but restored on exit.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,K).
  [in] | tau | COMPLEX_16 array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by ZGELQF.
  [in,out] | C | COMPLEX_16 array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) COMPLEX_16 array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance if SIDE = MagmaLeft, LWORK >= N*NB; if SIDE = MagmaRight, LWORK >= M*NB, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value